#include <Werte.h>
#include <Variablen.h>

// 1st initialization: Werte //
int Werte::_anl = 0;
unsigned long Werte::_new_time = 0;
unsigned long Werte::_nt_backup = 0;
unsigned long Werte::_old_time = 0;
unsigned long Werte::_delta = 0;
double Werte::_watt = 0;
double Werte::_in_stunden = 0;

// 1st initialization: Variablen //
int Variablen::_count = 0;
int Variablen::_cast = 0;
int Variablen::_timestamp = 0;
double Variablen::_place = 0;
bool Variablen::_flag = false;

void Werte::set_ANL(int var)
{
    _anl = var;
}

int Werte::get_ANL()
{
    return _anl;
}

// Checkt ab, ob der Wert kein Fehlwert war //
void Werte::check()
{
    _nt_backup = _new_time;
    _new_time = millis();
    
    _count = 0;
    _flag = false;

    while(_count != 4 && _flag != true)
    {
        _timestamp = millis() + 6;

        // Warte 5ms auf neuen Wert //
        while((_timestamp - millis()) > 0){millis();};
            if(get_ANL() >= 450)
            {
                _count++;
            }
            else
            {
                // Falschwert erfasst //
                _flag = true;
            }
    }
    
    Serial.println("-----------------------------------");

    if(_flag == true)
    {
        // Alten Wert wiederherstellen //
        _new_time = _nt_backup;
    }
    else
    {
        _old_time = _nt_backup;
        // Serial.printf("TIME: %d\n", Mess.NewTime); Überprüfe:
        nochimmer();
    }
}

// Überprüfen, ob statement noch immer zutrifft //
void Werte::nochimmer()
{
    _count = 0;

    while(1)
    {

        if(_count > 15)
        {
            break;
        }

        _timestamp = millis() + 6;
        while((_timestamp - millis()) > 0){millis();};
            if(get_ANL() < 430)
            {
                _count++;
            }
            else
            {
                continue;
            }
    }
    Serial.printf("\n\n\n\nSUCCESS\n\n\n\n");

    calc();
}

// Ausrechnen von Delta, Watt und eventueller Output //
void Werte::calc()
{
    if(_old_time != 0)
    {
        _delta = _new_time - _old_time;

        // Casting zu int ftf //
        _cast = _delta;
        _place = _cast / 1000;
        _in_stunden = 60 * (60 / _place);
        _watt = (1000 * _in_stunden) / 960;

        // OUTPUT //
        Serial.printf("Momentanverbauch:    DELTA: %d         WATT: %0.2f\n", _delta, _watt);
    }
}