#include <Arduino.h>
#include <Werte.h>
#include <Variablen.h>

#define AnalogPIN 14
#define DigitalPIN

void setup()
{
    // Initialisiere den Timer //
    void IRAM_ATTR onTimer();

    hw_timer_t *My_timer = 0;
    My_timer = timerBegin(0, 80, true);
    timerAttachInterrupt(My_timer, &onTimer, true);
    timerAlarmWrite(My_timer, 5000, true);
    timerAlarmEnable(My_timer);

    // Serielle Kommunikation //
    Serial.begin(115200);
}

void loop()
{
    // Serial.println(Werte::get_ANL());
    // ^ zum Überprüfen der Analog-Werte //

    // Wert möglicherweise vom Strich? //
    if(Werte::get_ANL() >= 450)
    {
      // Zeit New & Old richtig einlesen && Aufrufen von NOCHIMMER() //
      Werte::check();	
    }

}

void IRAM_ATTR onTimer()
{
    // Liest Wert ein ca jede 5ms //
    Werte::set_ANL(analogRead(AnalogPIN));
}